# imports
import os
os.environ['PYGAME_HIDE_SUPPORT_PROMPT'] = "hide"
# hide pygame welcome message
import pygame
from pygame.locals import *
from pygame import mixer
import random
import math
import time
import natsort
import pymongo
from pymongo import MongoClient
import pygame_textinput


# Pg++ Message
print("""
########   ######
##     ## ##    ##    ##     ##
##     ## ##          ##     ##
########  ##   #### ###### ######
##        ##    ##    ##     ##
##        ##    ##    ##     ##
##         ######

Built arround Pygame -- (Pg++) -- V1.1.1
""")


# Init pygame
pygame.mixer.pre_init(44100, 16, 2, 4096)
pygame.font.init()
pygame.init()


# Colors
BLACK = (0, 0, 0)
GRAY = (127, 127, 127)
WHITE = (255, 255, 255)
RED = (255, 0, 0)
GREEN = (0, 255, 0)
BLUE = (0, 0, 255)
YELLOW = (255, 255, 0)
CYAN = (0, 255, 255)
MAGENTA = (255, 0, 255)


# Variables
elements = {"mouse": {"id": "mouse", "type": "mouse", "rect": pygame.Rect(0, 0, 1, 1)}}
delays = {}
animations = {}
particles = {}
db = {}
posts = []
camara = {"x": 0, "y": 0}
scrollx = 0
scrolly = 0
autocamarachake = False
showfps = False
isButtonKPressed = False
devMode = False
BG = (255, 255, 255)


# MAIN


# WINDOW
def createWindow(title="Pg++", width=600, height=400, icon=False, type_=0):
    global WWIDTH, WHEIGHT, WIN
    WWIDTH = width
    WHEIGHT = height
    if type_ == 1:
        WIN = pygame.display.set_mode((width, height), pygame.RESIZABLE)
    elif type_ == 2:
        WIN = pygame.display.set_mode((0, 0), pygame.FULLSCREEN)
    elif type_ == 0:
        WIN = pygame.display.set_mode((width, height))
    pygame.display.set_caption(title)
    if icon:
        pygame.display.set_icon(pygame.image.load(icon).convert_alpha())

def setFullscreen():
    global WIN
    WIN = pygame.display.set_mode((0, 0), pygame.FULLSCREEN)

def setRescalable():
    global WIN, WWIDTH, WHEIGHT
    WIN = pygame.display.set_mode((WWIDTH, WHEIGHT), pygame.RESIZABLE)

def resetScreen():
    global WIN, WWIDTH, WHEIGHT
    WIN = pygame.display.set_mode((WWIDTH, WHEIGHT))

def setNormal():
    global WIN
    WWIDTH, WHEIGHT = pygame.display.get_surface().get_size()
    WIN = pygame.display.set_mode((WWIDTH, WHEIGHT))

def getWindowSize():
    return pygame.display.get_surface().get_size()


# OPTMIZE
def optimize():
    pygame.event.set_allowed([QUIT, KEYDOWN, KEYUP])


# FPS and delta time
def startClock():
    global clock
    clock = pygame.time.Clock()

def clockTick(fps=30):
    global clock
    clock.tick(fps)


# BACKGROUND
def setBackground(color=WHITE):
    global WIN, BG
    BG = color
    WIN.fill(color)


# DEV MODE
def turnOnDevMode():
    global devMode
    devMode = True

def turnOffDevMode():
    global devMode
    devMode = False

def toggleDevMode():
    global devMode
    devMode = not devMode


# EVENTS
def getEvents():
    return pygame.event.get()

def eventQuit():
    return pygame.QUIT

def newKeyPressed():
    return pygame.KEYDOWN

def getKeyPressed():
    return pygame.key.get_pressed()

def gameQuit():
    pygame.quit()


# MOUSE
def getMousePos():
    x,y = pygame.mouse.get_pos()
    return x, y

def leftClick():
    return pygame.mouse.get_pressed()[0]

def middleClick():
    return pygame.mouse.get_pressed()[1]

def rightClick():
    return pygame.mouse.get_pressed()[3]


# AUDIO
def startAudio(path, volume=100, loop=-1):
    global volume_
    volume_ = volume
    mixer.music.load(path)
    mixer.music.set_volume(volume/100)
    mixer.music.play(loop)

def setVolume(volume):
    mixer.music.set_volume(volume/100)

def increaseVol(v):
    setVolume(min(255, mixer.music.get_volume() + v))

def decreaseVol(v):
    setVolume(max(0, mixer.music.get_volume() - v))

def mute():
    mixer.music.set_volume(0.0)

def unmute():
    global volume_
    mixer.music.set_volume(volume_/100)

def toggleMute():
    if mixer.music.get_volume() == 0.0:
        unmute()
    else:
        mute()

def playAudio(path):
    sound = mixer.Sound(path)
    sound.play()



# KEYS
def keyA(): return pygame.K_a
def keyB(): return pygame.K_b
def keyC(): return pygame.K_c
def keyD(): return pygame.K_d
def keyE(): return pygame.K_e
def keyF(): return pygame.K_f
def keyG(): return pygame.K_g
def keyH(): return pygame.K_h
def keyI(): return pygame.K_i
def keyJ(): return pygame.K_j
def keyK(): return pygame.K_k
def keyL(): return pygame.K_l
def keyM(): return pygame.K_m
def keyN(): return pygame.K_n
def keyO(): return pygame.K_o
def keyP(): return pygame.K_p
def keyQ(): return pygame.K_q
def keyR(): return pygame.K_r
def keyS(): return pygame.K_s
def keyT(): return pygame.K_t
def keyU(): return pygame.K_u
def keyV(): return pygame.K_v
def keyW(): return pygame.K_w
def keyX(): return pygame.K_x
def keyY(): return pygame.K_y
def keyZ(): return pygame.K_z
def keyUP(): return pygame.K_UP
def keyLEFT(): return pygame.K_LEFT
def keyDOWN(): return pygame.K_DOWN
def keyRIGHT(): return pygame.K_RIGHT
def keyTAB(): return pygame.K_TAB
def keySHIFT(): return pygame.K_LSHIFT
def keyESC(): return pygame.K_ESCAPE
def keySPACE(): return pygame.K_SPACE
def keyCTRL(): return pygame.K_LCTRL
def key0(): return pygame.K_0
def key1(): return pygame.K_1
def key2(): return pygame.K_2
def key3(): return pygame.K_3
def key4(): return pygame.K_4
def key5(): return pygame.K_5
def key6(): return pygame.K_6
def key7(): return pygame.K_7
def key8(): return pygame.K_8
def key9(): return pygame.K_9





# DATABASE
def addDatabase(id, connection):
    global db
    cluster = MongoClient(connection)
    db[id] = {"cluster": cluster}

def insertInDB(id, daab, colle, postid, data):
    global db, posts
    post = data
    post["_id"] = postid
    posts.append(post)
    cluster = db[id]["cluster"]
    dab = cluster[daab]
    coll = dab[colle]
    coll.insert_one(post)

def deleteFromDB(id, daab, colle, feildname, value):
    global db
    cluster = db[id]["cluster"]
    dab = cluster[daab]
    coll = dab[colle]
    coll.delete_one({feildname: value})

def clearDB(id, daab, colle):
    global db
    cluster = db[id]["cluster"]
    dab = cluster[daab]
    coll = dab[colle]
    coll.delete_many({})

def setValueDB(id, daab, colle, _id, feildname, value):
    global db
    cluster = db[id]["cluster"]
    dab = cluster[daab]
    coll = dab[colle]
    coll.update_one({"_id": _id}, {"$set":{feildname: value}})

def removeValueDB(id, daab, colle, _id, feildname, value):
    global db
    cluster = db[id]["cluster"]
    dab = cluster[daab]
    coll = dab[colle]
    coll.update_one({"_id": _id}, {"$unset":{feildname: value}})

def increaseValueDB(id, daab, colle, _id, feildname, value):
    global db
    cluster = db[id]["cluster"]
    dab = cluster[daab]
    coll = dab[colle]
    coll.update_one({"_id": _id}, {"$inc":{feildname: value}})

def multiplyValueDB(id, daab, colle, _id, feildname, value):
    global db
    cluster = db[id]["cluster"]
    dab = cluster[daab]
    coll = dab[colle]
    coll.update_one({"_id": _id}, {"$mul":{feildname: value}})

def findInDB(id, daab, colle, feildname, value):
    global db
    cluster = db[id]["cluster"]
    dab = cluster[daab]
    coll = dab[colle]
    ans = coll.find({feildname: value})
    res = []
    for anw in ans:
        res.append(anw)
    return res

def readAllDB(id, daab, colle):
    global db
    cluster = db[id]["cluster"]
    dab = cluster[daab]
    coll = dab[colle]
    ans = coll.find({})
    res = []
    for anw in ans:
        res.append(anw)
    return res



# DRAW WINDOW
def drawWindow():
    global WIN, devMode, showfps, BG

    WIN.fill(BG)

    for sprite in elements.values(): # draw elements
        if sprite["type"] != "mouse": # if element is not mouse
            if sprite["haschanged"] == True: # if element must be updated
                if sprite["type"] == "colision": # if element type is colision
                    if devMode and sprite["show"] == True: # if colision must be shown
                        font = pygame.font.Font(None, 20)
                        text = font.render("ID: " + sprite["id"], True, (0, 0, 0))
                        sprite["rect"].x += camara["x"]
                        sprite["rect"].y += camara["y"]
                        pygame.draw.rect(WIN, (0, 0, 0), sprite["rect"], 2)
                        WIN.blit(text, (sprite["rect"].x, sprite["rect"].y-25))
                elif sprite["type"] == "sprite": # if element type is sprite
                    item = sprite["image"]
                    x = sprite["x"] - item.get_width()/2 + camara["x"]
                    y = sprite["y"] - item.get_height()/2 + camara["y"]
                    sprite["rect"].x = sprite["x"] - sprite["rect"].w/2 + camara["y"]
                    sprite["rect"].y = sprite["y"] - sprite["rect"].h/2 + camara["y"]
                    WIN.blit(item, (x, y))
                    if devMode and sprite["show"] == True:
                        font = pygame.font.Font(None, 20)
                        text = font.render("ID: " + sprite["id"], True, (0, 0, 0))
                        pygame.draw.rect(WIN, (0, 0, 0), sprite["rect"], 2)
                        WIN.blit(text, (sprite["rect"].x, sprite["rect"].y-25))
                elif sprite["type"] == "input":
                    WIN.blit(sprite["item"].surface, (sprite["x"], sprite["y"]))
                elif sprite["type"] == "text": # if element type is text
                    sprite["rect"].x = sprite["x"] - sprite["rect"].w/2 + camara["y"]
                    sprite["rect"].y = sprite["y"] - sprite["rect"].h/2 + camara["y"]
                    if devMode and sprite["show"] == True:
                        font = pygame.font.Font(None, 20)
                        text = font.render("ID: " + sprite["id"], True, (0, 0, 0))
                        pygame.draw.rect(WIN, (0, 0, 0), sprite["rect"], 2)
                        WIN.blit(text, (sprite["rect"].x, sprite["rect"].y-25))
                    WIN.blit(sprite["text"], sprite["rect"])

                sprite["haschanged"] = False # set must update to false
            else:
                if devMode: pass#print(sprite) # print sprite if is not updated

    mx, my = getMousePos()
    elements["mouse"] = {"id": "mouse", "type": "mouse", "rect": pygame.Rect(mx, my, 1, 1)}
    if devMode:
        font = pygame.font.Font(None, 20)
        text = font.render("X: " + str(mx) + " | Y: " + str(my), True, (0, 0, 0))
        WIN.blit(text, (mx, my-25))
    if devMode:
        font = pygame.font.Font(None, 20)
        text = font.render("FPS: " + getFps(), True, (0, 0, 0))
        WIN.blit(text, (10, 10))

    pygame.display.update() # update the window

def forceUpdate(id):
    elements[id]["haschanged"] = True


# SET ELEMENTS
# create a new element
def setElement(id, image, x=0, y=0, image_scale=100, colision_x=100, colision_y=100, rotation=0, flip=[False, False], colision_group=[1], group=1):
    image = pygame.image.load(image).convert_alpha()
    w, h = image.get_width(), image.get_height()
    size_x, size_y = image_scale*w/100, image_scale*h/100
    image = pygame.transform.flip(pygame.transform.rotate(pygame.transform.scale(image, (size_x, size_y)), rotation), flip[0], flip[1])
    elements[id] = {"id":id, "type": "sprite", "group":group, "image":image, "brightness": 0, "rect":pygame.Rect(x, y, colision_x, colision_y), "scale": image_scale, "x":x, "y":y, "sx":size_x, "sy":size_y, "r":rotation, "f":flip, "c":colision_group, "group": group, "show": True, "haschanged": True}

def setInput(id, x=0, y=0):
    elements[id] = {"id": id, "type": "input", "x": x, "y": y, "item": pygame_textinput.TextInputVisualizer(), "haschanged": True}

def updateInput(id, events):
    elements[id]["item"].update(events)

def getInputValue(id):
    return elements[id]["item"].value

def setColision(id, x, y, cx, cy, colision_group=[1], group=1):
    elements[id] = {"id":id, "type": "colision", "x": x, "y": y, "cx": cx, "cy": cy, "c": colision_group, "rect": pygame.Rect(x + cx/2, y + cy/2, cx, cy), "group": group, "show": True, "haschanged": True}

def writeText(id, string, font, x, y, fontSize, color=(200, 200, 200), group=1): #Function to set text
    font = pygame.font.Font(font, fontSize)
    text = font.render(string, True, color)
    textRect = text.get_rect()
    textRect.center = (x, y)
    elements[id] = {"id": id, "type": "text", "group":group, "text": text, "rect": textRect, "show": True, "haschanged": True}

def delay(id, seconds):
    if id in delays:
        if time.time() - delays[id][2] >= delays[id][1]:
            del delays[id]
            return True
        else:
            return False
    else:
        delays[id] = [id, float(seconds), time.time()]

def setParticles(id, textures, radius, density, type_):
    if type_ == "rain":
        pass


# IF STATEMENTS
def isElementPressed(id):
    global isButtonKPressed
    if isButtonKPressed == False:
        if isColiding("mouse", id) and mouseClick()[0]:
            isButtonKPressed = True
            return True
        else:
            return False
    elif isButtonKPressed == True and not mouseClick()[0]:
        isButtonKPressed = False
        return False
    else:
        return False

def isTouchingBorder(id):
    WWIDTH, WHEIGHT = getWindowSize()
    if elements[id]["x"] - elements[id]["sx"]/2 >= 0 and elements[id]["x"] + elements[id]["sx"]/2 <= WWIDTH:
        if elements[id]["y"] - elements[id]["sy"]/2 >= 0 and elements[id]["y"] + elements[id]["sy"]/2 <= WHEIGHT:
            return False
    return True

def isColiding(col1, col2):
    return pygame.Rect.colliderect(elements[col1]["rect"], elements[col2]["rect"])

def isColidingGroup(id, tgroup):
    for sprite in elements.values(): # get all elements
        if sprite['type'] != 'mouse':
            if sprite != elements[id]: # if target its not itself
                if not sprite["c"] == [0]: # if target has colision
                    for group in tgroup: # get colision group
                        if group in sprite["c"]: # if the colision group matches
                            if pygame.Rect.colliderect(sprite["rect"], elements[id]["rect"]):
                                return True, sprite['id']
    return False, None


# MODIFY ELEMENTS
def setElementSizeX(id, x):
    elements[id]["sx"] = x
    elements[id]["haschanged"] = True
    elements[id]["image"] = pygame.transform.flip(pygame.transform.rotate(pygame.transform.scale(elements[id]["image"], (elements[id]["sx"], elements[id]["sy"])), elements[id]["r"]), elements[id]["f"][0], elements[id]["f"][1])

def setElementSizeY(id, y):
    elements[id]["sy"] = y
    elements[id]["haschanged"] = True
    elements[id]["image"] = pygame.transform.flip(pygame.transform.rotate(pygame.transform.scale(elements[id]["image"], (elements[id]["sx"], elements[id]["sy"])), elements[id]["r"]), elements[id]["f"][0], elements[id]["f"][1])

def setColisionSizeX(id, x):
    elements[id]["cx"] = x
    elements[id]["haschanged"] = True

def setColisionSizeY(id, y):
    elements[id]["cy"] = y
    elements[id]["haschanged"] = True

def setScale(id, scale):
    w, h = elements[id]["image"].get_size()
    size_x, size_y = scale*w/100, scale*h/100
    setElementSizeX(id, size_x)
    setElementSizeY(id, size_y)

def delElement(id):
    try:
        del elements[id]
    except:
        pass

def setGhostEffect(id, effect):
    elements[id]["image"].set_alpha(effect)
    elements[id]["haschanged"] = True

def setImage(id, image):
    elements[id]["image"] = pygame.image.load(image).convert_alpha()
    if elements[id]["brightness"] < 0:
        elements[id]["image"].fill((int(str(elements[id]["brightness"]).replace("-", "")), int(str(elements[id]["brightness"]).replace("-", "")), int(str(elements[id]["brightness"]).replace("-", ""))), special_flags=pygame.BLEND_RGB_SUB)
    elif elements[id]["brightness"] > 0:
        elements[id]["image"].fill((elements[id]["brightness"], elements[id]["brightness"], elements[id]["brightness"]), special_flags=pygame.BLEND_RGB_ADD)
    elements[id]["haschanged"] = True
    elements[id]["image"] = pygame.transform.flip(pygame.transform.rotate(pygame.transform.scale(elements[id]["image"], (elements[id]["sx"], elements[id]["sy"])), elements[id]["r"]), elements[id]["f"][0], elements[id]["f"][1])

def setLoadedImage(id, image):
    elements[id]["image"] = image
    elements[id]["haschanged"] = True
    elements[id]["image"] = pygame.transform.flip(pygame.transform.rotate(pygame.transform.scale(elements[id]["image"], (elements[id]["sx"], elements[id]["sy"])), elements[id]["r"]), elements[id]["f"][0], elements[id]["f"][1])

def animate(id, anims, delay_=1):
    files_ = []
    if len(anims) == 1:
        for root, dirs, files in os.walk(anims[0]):
	        for file in files:
    		    files_.append(os.path.join(root,file))
        files_ = natsort.natsorted(files_, reverse=False)

    else:
        files_ = anims

    if id in animations:
        if animations[id]["anims"] == files_:
            if delay(id, delay_):
                if animations[id]["currentAnim"] >= len(files_)-1:
                    animations[id]["currentAnim"] = 0
                else:
                    animations[id]["currentAnim"] += 1
                setImage(id, animations[id]["anims"][animations[id]["currentAnim"]])
        else:
            animations[id] = {"id": id, "anims": files_, "currentAnim": 0, "delay": delay_}
    else:
        animations[id] = {"id": id, "anims": files_, "currentAnim": 0, "delay": delay_}
    elements[id]["haschanged"] = True

def flip(id, flip=[False, False]):
    elements[id]["f"] = flip
    elements[id]["haschanged"] = True
    elements[id]["image"] = pygame.transform.flip(elements[id]["image"], elements[id]["f"][0], elements[id]["f"][1])

def hideElement(id):
    if elements[id]["type"] != "colision":
        setGhostEffect(id, 0)
    elements[id]["show"] = False
    elements[id]["haschanged"] = False

def showElement(id):
    if elements[id]["type"] != "colision":
        setGhostEffect(id, 255)
    elements[id]["show"] = True
    elements[id]["haschanged"] = True

def setBrightness(id, brightness):
    elements[id]["image"].fill((brightness, brightness, brightness), special_flags=pygame.BLEND_RGB_ADD)
    elements[id]["brightness"] += brightness
    elements[id]["haschanged"] = True

def setDarkness(id, brightness):
    elements[id]["image"].fill((brightness, brightness, brightness), special_flags=pygame.BLEND_RGB_SUB)
    elements[id]["brightness"] += brightness*-1
    elements[id]["haschanged"] = True


# MOVE ELEMENTS
def moveXElement(id, x):
    elements[id]["x"] += x
    elements[id]["haschanged"] = True

def moveYElement(id, y):
    elements[id]["y"] += y
    elements[id]["haschanged"] = True

def moveXColision(id, x):
    elements[id]["x"] += x
    elements[id]["haschanged"] = True

def moveYColision(id, y):
    elements[id]["y"] += y
    elements[id]["haschanged"] = True

def tryMoveXElement(id, x):
    WWIDTH = getWindowSize()[0]
    # check if touching window border
    if elements[id]["x"] - elements[id]["sx"]/2 + x >= 0 and elements[id]["x"] + elements[id]["sx"]/2 + x <= WWIDTH:
        if elements[id]["c"] != [0]: # check if the player is colision
            elements[id]["rect"].x += x
            for sprite in elements.values():
                if sprite['type'] != 'mouse':
                    if sprite["show"] == True:
                        if not sprite == elements[id]: # if target its not itself
                            if sprite["c"] != [0]: # if target has colision
                                for group in elements[id]["c"]: # get colision group
                                    if group in sprite["c"]: # if the colision group matches
                                        if pygame.Rect.colliderect(sprite["rect"], elements[id]["rect"]):
                                            elements[id]["rect"].x += x*-1
                                            if autocamarachake == True:
                                                camaraShake(5)
                                            return False
        moveXElement(id, x)
        if autocamarachake == True:
            resetCamara()
        return True

def tryMoveYElement(id, y):
    WHEIGHT = getWindowSize()[1]
    if elements[id]["y"] - elements[id]["sy"]/2 + y >= 0 and elements[id]["y"] + elements[id]["sy"]/2 + y <= WHEIGHT:
        if elements[id]["c"] != [0]: # check if the player is colision
            elements[id]["rect"].y += y
            for sprite in elements.values():
                if sprite['type'] != 'mouse':
                    if sprite["show"] == True:
                        if not sprite == elements[id]: # if target its not itself
                            if sprite["c"] != [0]: # if target has colision
                                for group in elements[id]["c"]: # get colision group
                                    if group in sprite["c"]: # if the colision group matches
                                        if pygame.Rect.colliderect(sprite["rect"], elements[id]["rect"]):
                                            elements[id]["rect"].y += y*-1
                                            if autocamarachake == True:
                                                camaraShake(5)
                                            return False
        moveYElement(id, y)
        if autocamarachake == True:
            resetCamara()
        return True

def setXElement(id, x):
    elements[id]["x"] = x
    elements[id]["haschanged"] = True

def setYElement(id, y):
    elements[id]["y"] = y
    elements[id]["haschanged"] = True

def setXColision(id, x):
    elements[id]["rect"].x = x
    elements[id]["haschanged"] = True

def setYColision(id, y):
    elements[id]["rect"].y = y
    elements[id]["haschanged"] = True

def moveInDirection(id, r, steps):
    x = math.sin(math.radians(r)) * steps
    y = math.cos(math.radians(r)) * steps
    moveXElement(id, x*-1)
    moveYElement(id, y*-1)

def tryMoveInDirection(id, r, steps):
    x = math.sin(math.radians(r)) * steps
    y = math.cos(math.radians(r)) * steps
    tryMoveXElement(id, x*-1)
    tryMoveYElement(id, y*-1)

def moveTowards(id, target, steps):
    angle = math.degrees(math.atan2(elements[target]["x"] - elements[id]["x"], elements[target]["y"] - elements[id]["y"])) + 180
    moveInDirection(id, angle, steps)

def tryMoveTowards(id, target, steps):
    angle = math.degrees(math.atan2(elements[target]["x"] - elements[id]["x"], elements[target]["y"] - elements[id]["y"])) + 180
    tryMoveInDirection(id, angle, steps)

def point(id, angle):
    elements[id]["r"] = angle
    elements[id]["haschanged"] = True
    elements[id]["image"] = pygame.transform.rotate(elements[id]["image"], elements[id]["r"])

def turn(id, degrees):
    elements[id]["r"] += degrees
    elements[id]["haschanged"] = True
    elements[id]["image"] = pygame.transform.flip(pygame.transform.rotate(pygame.transform.scale(elements[id]["image"], (elements[id]["sx"], elements[id]["sy"])), elements[id]["r"]), elements[id]["f"][0], elements[id]["f"][1])

def pointTowards(id, target):
    point(id, math.degrees(math.atan2(elements[target]["x"] - elements[id]["x"], elements[target]["y"] - elements[id]["y"])) + 180)
    elements[id]["haschanged"] = True

def pointTowardsMouse(id):
    x, y = getMousePos()
    point(id, math.degrees(math.atan2(x - elements[id]["x"], y - elements[id]["y"])) + 180)
    elements[id]["haschanged"] = True

def setCamaraX(x):
    camara["x"] = x
    for element in elements.values():
        element["haschanged"] = True

def setCamaraY(y):
    camara["y"] = y
    for element in elements.values():
        element["haschanged"] = True

def moveCamaraX(x):
    camara["x"] += x
    for element in elements.values():
        element["haschanged"] = True

def moveCamaraY(y):
    camara["y"] += y
    for element in elements.values():
        element["haschanged"] = True

def scrollX(id, x):
    global scrollx
    scrollx += x
    return scrollx*-1

def scrollY(id, y):
    global scrolly
    scrolly += y
    return scrolly*-1

def tryScrollX(id, x):
    global scrollx
    if tryMoveXElement(id, x):
        moveXElement(id, x*-1)
        scrollx += x
        return scrollx*-1
    else:
        return scrollx*-1

def tryScrollY(id, y):
    global scrolly
    if tryMoveYElement(id, y):
        moveYElement(id, y*-1)
        scrolly += y
        return scrolly*-1
    else:
        return scrolly*-1

def scrollInDirection(id, r, steps):
    px, py = getXElement(id), getYElement(id)
    moveInDirection(id, r, steps)
    x, y = getXElement(id), getYElement(id)
    sx = scrollX(id, px-x)
    sy = scrollY(id, py-y)
    return sx, sy

def tryScrollInDirection(id, r, steps):
    px, py = getXElement(id), getYElement(id)
    moveInDirection(id, r, steps)
    x, y = getXElement(id), getYElement(id)
    sx = tryScrollX(id, px-x)
    sy = tryScrollY(id, py-y)
    return sx, sy


# GET ELEMENT PROPERTIES
def getXElement(id):
    return elements[id]["x"]

def getYElement(id):
    return elements[id]["y"]

def getXColision(id):
    return elements[id]["x"]

def getYColision(id):
    return elements[id]["y"]

def getRotation(id):
    return elements[id]["r"]


# UTILITY
def showLayers():
    for idx, v in enumerate(elements):
        print(str(idx+1) + " -" + "-"*idx + " " + v)

def pickRandom(start, end):
    return random.randint(start, end)

def loadImage(path):
    return pygame.image.load(path).convert_alpha()

def camaraShake(range):
    resetCamara()
    camara["x"] += pickRandom(range*-1, range)
    camara["y"] += pickRandom(range*-1, range)
    for element in elements.values():
        element["haschanged"] = True

def resetCamara():
    camara["x"] = 0
    camara["y"] = 0
    for element in elements.values():
        element["haschanged"] = True

def elementsInGroup(group):
    el = []
    for element in elements.values():
        if element["type"] != "mouse" and element["type"] != "colision":
            if element["group"] == group:
                el.append(element["id"])
    return el

def autoCamaraShake(camshake):
    global autocamarachake
    autocamarachake = camshake
    for element in elements.values():
        element["haschanged"] = True

def toggleFps():
    global showfps
    showfps = not showfps
    elements[id]["haschanged"] = True

def hideFps():
    global showfps
    showfps = False

def showFps():
    global showfps
    showfps = True

def getFps():
    global clock
    return str(round(clock.get_fps()))
